from automatic_contract_creation.scr.llama.llama_model import LlamaModel


class LlamaDescription(LlamaModel):
    def get_business_description(self, col_nm:str=None, description:str=None)->str:
        prompt = [{
            'role': 'system',
            'content': '''
            Ты ассистент помошник главная задача которого убрать лишнее описание, 
            ипользуя контекст ниже.
           
            Ты получишь 2 объекта:
            - наименование колонки в базе данных
            - описание колонки на русском.
            
            Ты должен сократить описание, но только когда 
            это в описании присутствует много излишней информации.
            Если описание содержит только короткое описание тогда ничего не меняй 
            просто верни тоже самое описание, что и было на входе
            
            Если ты получишь пустой объект просто верни False
            
            Пару примеров как это должно работать:
            Пример 1ый 
            на вход получено:
            event                Тип события - создание заказа: const=create - отмена заказа: const=reject
            
            В этом случае ты должен вернуть: 'Тип события'
            
            Пример 2 
            на вход получено:
            order__app_version   Версия платформы клиента
            
            В этом случае тебе не нужно ничего менять верни ту же информацию, что и получил:
            'Версия платформы клиента'
            
            Постарайся сохранить главный смысл из описания, например, если ты получишь ввод:
            'counter_id Идентификатор счетчика системы-поставщика данных
            Список: счетчиков: https://youtrack.kljdncfl.rju/articles//countername'
            то в ответе ты должен сохранить главный смысл  и вернуть
            'Идентификатор счетчика системы-поставщика данных', а не просто идентификатор счетчика
            
            
            Если ты получишь на вход только наименование колонки, а описание будет '',
            то верни 'False'.
            
            Весь процесс выглядит следующим образом:
            вход:<наименование колонки>, <описание>
            выход:<сокращенное описание>
            
            вход:<наименование колонки>, ''
            выход: False
            
            Верни только сокращенное описание не добавляй никаких дополнительных комментарий!
            '''},
            {
                'role': 'user',
                'content': f'{col_nm}, {description}'
            }]

        response = self.get_response(prompt)

        return response

